#ifndef __LIST_CPP__RAM__

#define __LIST_CPP__RAM__

#ifndef NULL
#define NULL 0
#endif


template< class T >
struct element
{
	T *obj;
	element *next;
};

template< class T >
class list
{
	private:
		element<T> *first;
		element<T> *last;
		element<T> *currPointer;
		int count;
	public:
		list() { first = last = currPointer = NULL;count=0; }
		T* insInFront(T*);
		T* insInRear(T*);
		T* insBefore(T*,T*);
		T* insAfter(T*,T*);
		T* delInFront();
		T* delInRear();
		T* delObj(T*);
		element<T>* lookFor(T*);
		T* lookForObj(T*);
		int isEmpty() { return ( first == NULL ); }
		T* get();
		T* getn(int);
		void rewind();
		int getCount();
		T* operator [] (int);
};

template< class T >
T* list<T> :: insInFront(T *t)
{
	T *o = lookForObj(t);
	if( o != NULL ) return o;
	element<T>* newElement = new element<T>;
	newElement->obj = t;
	newElement->next = first;
	first = newElement;
	if(last == NULL) last=newElement;
	count++;
	return newElement->obj;
}

template< class T >
T* list<T> :: insInRear(T *t)
{
	T *o = lookForObj(t);
	if( o != NULL ) return o;
	element<T>* newElement = new element<T>;
	newElement->obj = t;
	if(last==NULL) { first = last = newElement; }
	else
	{
		newElement->next = last->next;
		last->next = newElement;
		last = newElement;
	}
	count++;
	return newElement->obj;
}

template< class T >
T* list<T> :: insAfter(T *where, T* t)
{
	T *o = lokForObj(t);
	if(o != NULL) return o;
	element<T> *et = lookFor(where);
	element<T> *newElement = new element<T>;
	if(et == NULL) return NULL;
	if(et == last) return insInRear(t);
	newElement->obj = t;
	newElement->next = et->next;
	et->next = newElement;
	count++;
	return newElement->obj;
}

template< class T >
T* list<T> :: insBefore(T *where, T* t)
{
	T *o = lookForObj(t);
	if( o != NULL ) return o;
	element<T> *et = lookFor(where);
	element<T> *newElement = new element<T>;
	if(et == NULL) return NULL;
	if(et == first) return insInFront(t);
	newElement->obj = t;
	newElement->next = et;
	element<T> *cur = first;
	while(cur->next != et) cur = cur->next;
	cur->next = newElement;
	count++;
	return newElement->obj;
}

template< class T >
T* list<T> :: delInFront()
{
	T* t = first->obj;
	element<T> *tmp = first;
	first = first->next;
	tmp->obj=NULL;
	tmp->next=NULL;
	delete tmp;
	if(first==NULL) last=first;
	count--;
	return t;
}

template< class T >
T* list<T> :: delInRear()
{
	T* t = last->obj;
	if( first==last ) return delInFront();
	element<T> *tmp = last;
	element<T> *cur = first;
	while(cur->next != last) cur=cur->next;
	last=cur;
	last->next = NULL;
	tmp->obj = NULL;
	tmp->next = NULL;
	delete tmp;
	count--;
	return t;
}

template< class T >
T* list<T> :: delObj(T *t)
{
	element<T> *et = lookFor(t);
	if( et == NULL ) return NULL;
	if( et == first ) return delInFront();
	if( et == last ) return delInRear();
	element<T> *cur = first;
	while(cur->next != et) cur=cur->next;
	cur->next = et->next;
	t = et->obj;
	et->obj = NULL;
	et->next = NULL;
	delete et;
	count--;
	return t;
}

template< class T >
element<T>* list<T> :: lookFor(T *t)
{
	element<T> *cur = first;
	if( first->obj == t ) return first;
	while(  (cur!=NULL) && ( (*(cur->obj)) != (*t)) )
	{
		cur=cur->next;
	}
	return cur;
}

template< class T >
T* list<T> :: lookForObj(T *t)
{
	element<T> *cur = first;
	while( cur!=NULL && *(cur->obj) != *t )
		cur=cur->next;
	if( cur == NULL ) return NULL;
	return cur->obj;
}

template< class T >
void list<T> :: rewind()
{
	currPointer=first;
}

template< class T >
T* list<T> :: get()
{
	if(currPointer == NULL) { currPointer=first; }
	T* o = currPointer->obj;
	currPointer=currPointer->next;
	return o;
}

template< class T >
int list<T> :: getCount()
{
	return count;
}

template< class T >
T* list<T> :: getn(int i)
{
	element<T>* curr = first;
	while(i && curr)
	{
		curr=curr->next;
		i--;
	}
	return curr->obj;
}

template< class T >
T* list<T> :: operator [] (int i)
{
	return getn(i);
}


#endif
