#ifndef __3DMATHDEF_CPP__

#define __3DMATHDEF_CPP__

#include "include.cpp"


class Point;
class Vector;
class Triangle;
class Line;




int n;
int
ran (int max)
{
  return random () % max + 1;
}


class Point
{

public:

  float x, y, z, dist;

    Point ()
  {
  }


  Point (float x1, float y1, float z1)
  {


    x = x1;
    y = y1;
    z = z1;


    dist = sqrt ((x * x) + (y * y) + (z * z));


  }


  void calcDist ()
  {


    dist = sqrt ((x * x) + (y * y) + (z * z));


  }



  void print ()
  {



    cout << endl << "(" << x << "," << y << "," << z << ")";



  }



  void printOn (ostream & o)
  {


    o << endl << "(" << x << "," << y << "," << z << ")";


  }



  int operator != (Point p)
  {


    return (int (100 * x) != int (100 * p.x) ||
	    int (100 * y) != int (100 * p.y) ||
	    int (100 * z) != int (100 * p.z));


  }



};




class Vector
{

public:

  float i, j, k;



    Vector ()
  {

    //i=j=k=0.0;
  }



  Vector (float i1, float j1, float k1)
  {

    i = i1;

    j = j1;

    k = k1;
  }


  Vector (Point p)
  {

    i = p.x;

    j = p.y;

    k = p.z;

  }


  Vector CrossProduct (Vector v)
  {

    return Vector (j * v.k - k * v.j, k * v.i - i * v.k, i * v.j - j * v.i);

  }



  float DotProduct (Vector v)
  {

    return (i * v.i + j * v.j + k * v.k);

  }


  Vector Normalise ()
  {

    float ii, jj, kk;

    float n = sqrt ((i * i) + (j * j) + (k * k));

    ii = i / n;
    jj = j / n;
    kk = k / n;

    return Vector (ii, jj, kk);

  }


  int isEqual (Vector v)
  {

    return ((v.i == i) && (v.j == j) && (v.k == k));

  }


  Vector operator - (Vector v)
  {

    return Vector (i - v.i, j - v.j, k - v.k);

  }




};


class Line
{

public:

  Point pt;
  Vector m;

    Line (Point p, Vector v)
  {
    m = v.Normalise ();
    pt = p;
  }

  Line (Point p1, Point p2)
  {
    if (p1.dist > p2.dist)
      {
	Point t = p1;
	p1 = p2;
	p2 = t;
      }
    pt = p1;
    m = Vector (p2.x - p1.x, p2.y - p1.y, p2.z - p1.z);
    m = m.Normalise ();
  }

  int pointOnLine (Point p)
  {
    return (((p.x - pt.x) * m.j) == ((p.y - pt.y) * m.i)
	    && ((p.x - pt.x) * m.k) == ((p.z - pt.z) * m.i));
  }

};


class Plane
{

public:
  Vector n;
  float dist;

    Plane ()
  {
  }


  int OnWhatSide (Point r)
  {
    Vector v (r.x, r.y, r.z);
    float a = v.DotProduct (n);
    return (a >= 0);
  }

  int isParallel (Plane p)
  {
    return (n.isEqual (p.n));
  }

  int isEqual (Plane p)
  {
    return (n.isEqual (p.n) && (dist == p.dist));
  }



};


Point
ptLinePlane (Line l, Plane p)
{

  float lambda, a, b, c, d, x, y, z, p1, p2, p3, m1, m2, m3;

  a = p.n.i;
  b = p.n.j;
  c = p.n.k;
  d = p.dist;
  m1 = l.m.i;
  m2 = l.m.j;
  m3 = l.m.k;
  p1 = l.pt.x;
  p2 = l.pt.y;
  p3 = l.pt.z;

  lambda = (d - a * p1 - b * p2 - c * p3);
  lambda = lambda / (a * m1 + b * m2 + c * m3);

  x = p1 + lambda * m1;
  y = p2 + lambda * m2;
  z = p3 + lambda * m3;

  return (Point (x, y, z));
}


class Triangle
{
public:
  Point * pts[3];
  Vector normal;
    Triangle ()
  {
  }

  Triangle (Point * p1, Point * p2, Point * p3)
  {
    Triangle ();
    pts[0] = p1;
    pts[1] = p2;
    pts[2] = p3;
    Vector a = Vector (*p2) - Vector (*p1);
    Vector b = Vector (*p3) - Vector (*p1);
    normal = a.CrossProduct (b);
    normal = normal.Normalise ();

  }
  Triangle (Point p1, Point p2, Point p3)
  {
    Point *pt1 = new Point;
    Point *pt2 = new Point;
    Point *pt3 = new Point;

    *pt1 = p1;
    *pt2 = p2;
    *pt3 = p3;


    Triangle (pt1, pt2, pt3);
  }

  void calcNormal ()
  {
    Vector a = Vector (*pts[1]) - Vector (*pts[0]);
    Vector b = Vector (*pts[2]) - Vector (*pts[0]);
    normal = a.CrossProduct (b);
    normal = normal.Normalise ();
  }

  void getPlane ()
  {
  }
  int operator != (Triangle t)
  {
    return (*(pts[0]) != *(t.pts[0]) ||
	    *(pts[1]) != *(t.pts[1]) || *(pts[2]) != *(t.pts[2]));
  }

  void print ()
  {
    cout << endl << "Triangle:" << endl << "Vertex 0:";
    pts[0]->print ();
    cout << endl << "Vertex 1:";
    pts[1]->print ();
    cout << endl << "Vertex 2:";
    pts[2]->print ();
  }

  void printOn (ostream & o)
  {
    o << endl << "Triangle:" << endl << "Vertex 0:";
    pts[0]->printOn (o);
    o << endl << "Vertex 1:";
    pts[1]->printOn (o);
    o << endl << "Vertex 2:";
    pts[2]->printOn (o);
  }

  int OnWhatSide (Point p)
  {
    float a = normal.DotProduct (Vector (p));
    float b = normal.DotProduct (Vector (*(pts[0])));
    return (a > b);		// return (a<=b) ? 0:1;
  }

  Point IntersectionPoint (Point b, Point e)
  {
    float h = normal.DotProduct (b);
    float k = normal.DotProduct (e);
    float n = normal.DotProduct (*(pts[0]));
    float c = (n - h) / (k - h);
    float fx = (b.x + c * (e.x - b.x));
    float fy = (b.y + c * (e.y - b.y));
    float fz = (b.z + c * (e.z - b.z));
    return Point (fx, fy, fz);
  }


};


Vector lightSrc;
Vector viewDir;
Point viewPos;
int focalDist;

void
convertToAligned (Point * pt, Vector dir, Point pos)
{
  pt->x = pt->x - pos.x;
  pt->y = pt->y - pos.y;
  pt->z = pt->z - pos.z;
}


void
tran3d_2d (Point pt, int &x, int &y)
{
  convertToAligned (&pt, viewDir, viewPos);
  float fx = focalDist * pt.x;
  float fy = focalDist * pt.y;
  if (!pt.z)
    pt.z = 1;
  x = int (fx / pt.z) + CentreX;
  y = int (fy / pt.z) + CentreY;
}


#endif
