#ifndef __3DTERRAIN_CPP__

#define __3DTERRAIN_CPP__

#include "include.cpp"

#include "obj3D.cpp"

Object3D* generateTerrain(int length, int breadth, XColor xc, int n=10, int iter=10)
{
	//Point **ptmat = new Point*[n];
	list<Point> *ptmat = new list<Point>[n];
	int i=0,j,k;
	int max=10,min=5;
	int rad=0;
	int x,z;
	float miny,maxy=0;

	/*
	for(i=0;i<n;i++)
		ptmat[i] = new Point[n];
	*/


	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		{
			/*
			ptmat[i][j].x = j-n/2;
			ptmat[i][j].z = i-n/2;
			ptmat[i][j].y = 0;
			*/
			ptmat[i].insInRear( new Point( j-n/2, 0, i-n/2 ) );
		}
	}


	for(k=0;k<iter;k++)
	{
		rad = min + ran(max - min);
		x = ran(n);
		z = ran(n);
		

		for( i=z-rad;i<z+rad;i++)
		{
			for(j=x-rad;j<x+rad;j++)
			{
				if( i>=0 && j>=0 && i<n && j<n )
				{
					ptmat[i][j]->y += rad*rad - (i-z)*(i-z) - (j-x)*(j-x);
					if(ptmat[i][j]->y < 0) ptmat[i][j]->y=0;
					maxy = (maxy < ptmat[i][j]->y) ? ptmat[i][j]->y : maxy;
				}
			}
		}
	}

	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		{
			ptmat[i][j]->y = n * ptmat[i][j]->y / maxy;
		}
	}


	list<Point> *PointList = new list<Point>;
	list<Triangle> *TriangleList = new list<Triangle>;
	list<Facet> *FacetList = new list<Facet>;
	Triangle *tr;
	Facet *f;
	Point *p1,*p2,*p3;

	for(i=0;i<n-1;i++)
	{
		for(j=0;j<n;j++)
		{
			if(j+1 < n)
			{
				p1 = ptmat[i][j];
				p2 = ptmat[i+1][j];
				p3 = ptmat[i][j+1];
				p1 = PointList->insInRear(p1);
				p2 = PointList->insInRear(p2);
				p3 = PointList->insInRear(p3);
				
				tr = new Triangle(p1, p2, p3);
				tr = TriangleList->insInRear(tr);
				f = new Facet( tr, xc);
				f = FacetList->insInRear(f);
			}
			if( j>=1 )
			{
				p1 = ptmat[i][j];
				p2 = ptmat[i+1][j-1];
				p3 = ptmat[i+1][j];
				p1 = PointList->insInRear(p1);
				p2 = PointList->insInRear(p2);
				p3 = PointList->insInRear(p3);
				
				tr = new Triangle(p1, p2, p3 );
				tr = TriangleList->insInRear(tr);
				f = new Facet( tr, xc );
				f = FacetList->insInRear(f);
			}
		}
	}
			
	
	Object3D *obj = new Object3D;

	obj->PointList = PointList;
	obj->TriangleList = TriangleList;
	obj->FacetList = FacetList;

	return obj;
}


#endif
