#ifndef __3DTRANSFORMATIONS_CPP__

#define __3DTRANSFORMATIONS_CPP__

#include "include.cpp"

#include "3Dmathdef.cpp"
#include "3Dfacet.cpp"
#include "obj3D.cpp"


	float** allocMatrix(float **mat,int n=4)
	{
		float **retmat;
		//float *mat[4] = new float[4][4];
		//retmat = mat;
		mat = new float*[n];
		for(int i=0;i<n;i++)
			mat[i] = new float[n];
		retmat = mat;
		return retmat;
	}

	void setZero(float **mat, int n=4)
	{
		int i,j;
		if(mat!=NULL)
			for(i=0;i<n;i++)
				for(j=0;j<n;j++)
					mat[i][j]=0;
	}
	

	void MatCopy(float **source /*[4][4]*/ ,float **dest /*[4][4]*/ ,int n=4)
	{
	    int i,j;
	    for(i=0; i<n; i++)
	      for(j=0; j<n; j++)
		  dest[i][j]=source[i][j];
	} 

       void MatMult(float **mat1,
		    float **mat2,
		    float **dest,int n=4 )//float mat1[4][4], float mat2[4][4], float dest[4][4])
	{	
	   int i,j,k;
	   setZero(dest);
	   for(i=0; i<n; i++)
	   	for(j=0; j<n; j++)
		      for(k=0;k<n;k++)
			      dest[i][j]+=mat1[i][k]*mat2[k][j];
	}

      void VecMultMatrix(Point *Source,float **mat,Point *Dest,int n=4)
	{
    		Dest->x=Source->x*mat[0][0]+
            	Source->y*mat[0][1]+
            	Source->z*mat[0][2]+
                mat[0][3];
		
		Dest->y=Source->x*mat[1][0]+
	        Source->y*mat[1][1]+
        	Source->z*mat[1][2]+
                mat[1][3];
	       
		Dest->z=Source->x*mat[2][0]+
               	Source->y*mat[2][1]+
                Source->z*mat[2][2]+
                mat[2][3];

	}



	void MatIdentity(float **mat,int n=4)
	{
	    int i;
	    setZero(mat);
	    for(i=0;i<n;i++)
	    {
		    mat[i][i] = 1;
	    }
	}

	float** Translate(float **matrix ,float tx,float ty,float tz)
	{
	   float **tmat, **res;
	   
	   tmat = allocMatrix(tmat);
	   res = allocMatrix(res);
	   
	   tmat[0][0]=1;  tmat[0][1]=0;  tmat[0][2]=0;  tmat[0][3]=tx;
	   tmat[1][0]=0;  tmat[1][1]=1;  tmat[1][2]=0;  tmat[1][3]=ty;
	   tmat[2][0]=0;  tmat[2][1]=0;  tmat[2][2]=1;  tmat[2][3]=tz;
	   tmat[3][0]=0;  tmat[3][1]=0;  tmat[3][2]=0;  tmat[3][3]=1;
	   
	   MatMult(tmat,matrix,res);
	   MatCopy(res,matrix);
	   
	   return matrix;
	}
        
        void createMatrix(Facet *f,float matrix[4][4])
         { 
		 matrix[0][0]=f->tr->pts[0]->x;
		 matrix[0][1]=f->tr->pts[0]->y;
		 matrix[0][2]=f->tr->pts[0]->z;
		 matrix[0][3]=1;
		 matrix[1][0]=f->tr->pts[1]->x;
		 matrix[1][1]=f->tr->pts[1]->y;
		 matrix[1][2]=f->tr->pts[1]->z;
		 matrix[1][3]=1;
		 matrix[2][0]=f->tr->pts[2]->x;
		 matrix[2][1]=f->tr->pts[2]->y;
		 matrix[2][2]=f->tr->pts[2]->z;
		 matrix[2][3]=1;
		 matrix[3][0]=0;
		 matrix[3][1]=0;
		 matrix[3][2]=0;
		 matrix[3][3]=1;
           
	 }
	void Scale(float **matrix,//matrix[4][4],
		   float sx,
		   float sy,
		   float sz)
	{
	   //float smat[4][4],mat1[4][4];
	   float **smat, **mat1;
	   // smat = new float[4][4];
	   // mat1 = new float[4][4];
	   smat = allocMatrix(smat);
	   mat1 = allocMatrix(mat1);
	   smat[0][0]=sx; smat[0][1]=0;  smat[0][2]=0;  smat[0][3]=0;
	   smat[1][0]=0;  smat[1][1]=sy; smat[1][2]=0;  smat[1][3]=0;
	   smat[2][0]=0;  smat[2][1]=0;  smat[2][2]=sz; smat[2][3]=0;
	   smat[3][0]=0;  smat[3][1]=0;  smat[3][2]=0;  smat[3][3]=1;
	   MatMult(matrix,smat,mat1);
	   MatCopy(mat1,matrix);
	}
/*
	void Rotate(float **matrix,  //(float matrix[4][4],
		    float ax,
		    float ay,
		    float az)
	{
	   float **xmat, **ymat, **zmat, **mat2, **mat1;

	   xmat = allocMatrix(xmat);
	   ymat = allocMatrix(ymat);
	   zmat = allocMatrix(zmat);
	   mat1 = allocMatrix(mat1);
	   mat2 = allocMatrix(mat2);
	   
	   xmat[0][0]=1;        xmat[0][1]=0;        xmat[0][2]=0;        xmat[0][3]=0;
	   xmat[1][0]=0;        xmat[1][1]=cos(ax);  xmat[1][2]=sin(ax);  xmat[1][3]=0;
	   xmat[2][0]=0;        xmat[2][1]=-sin(ax); xmat[2][2]=cos(ax);  xmat[2][3]=0;
	   xmat[3][0]=0;        xmat[3][1]=0;        xmat[3][2]=0;        xmat[3][3]=1;

	   ymat[0][0]=cos(ay);  ymat[0][1]=0;        ymat[0][2]=-sin(ay); ymat[0][3]=0;
	   ymat[1][0]=0;        ymat[1][1]=1;        ymat[1][2]=0;        ymat[1][3]=0;
	   ymat[2][0]=sin(ay);  ymat[2][1]=0;        ymat[2][2]=cos(ay);  ymat[2][3]=0;
	   ymat[3][0]=0;        ymat[3][1]=0;        ymat[3][2]=0;        ymat[3][3]=1;

	   zmat[0][0]=cos(az);  zmat[0][1]=sin(az);  zmat[0][2]=0;        zmat[0][3]=0;
	   zmat[1][0]=-sin(az); zmat[1][1]=cos(az);  zmat[1][2]=0;        zmat[1][3]=0;
	   zmat[2][0]=0;        zmat[2][1]=0;        zmat[2][2]=1;        zmat[2][3]=0;
	   zmat[3][0]=0;        zmat[3][1]=0;        zmat[3][2]=0;        zmat[3][3]=1;


	}
*/

float** Rotatex(float **mat, float ax)
{
	float **xmat;
	xmat = allocMatrix(xmat);
	float **res;
	res = allocMatrix(res);
	
	xmat[0][0]=1;        xmat[0][1]=0;        xmat[0][2]=0;        xmat[0][3]=0;
	xmat[1][0]=0;        xmat[1][1]=cos(ax);  xmat[1][2]=sin(ax);  xmat[1][3]=0;
	xmat[2][0]=0;        xmat[2][1]= -sin(ax); xmat[2][2]=cos(ax);  xmat[2][3]=0;
	xmat[3][0]=0;        xmat[3][1]=0;        xmat[3][2]=0;        xmat[3][3]=1;

	MatMult(xmat, mat, res);
	MatCopy(res, mat);
	return mat;
}

float** Rotatey(float **mat, float ay)
{
	float **ymat;
	ymat = allocMatrix(ymat);
	float **res;
	res = allocMatrix(res);
	
	ymat[0][0]=cos(ay);  ymat[0][1]=0;        ymat[0][2]=sin(ay);  ymat[0][3]=0;
	ymat[1][0]=0;        ymat[1][1]=1;        ymat[1][2]=0;        ymat[1][3]=0;
	ymat[2][0]= -sin(ay); ymat[2][1]=0;        ymat[2][2]=cos(ay);  ymat[2][3]=0;
	ymat[3][0]=0;        ymat[3][1]=0;        ymat[3][2]=0;        ymat[3][3]=1;

	MatMult(ymat, mat, res);
	MatCopy(res, mat);
	return mat;
}

float** Rotatez(float **mat, float az)
{
	float **zmat;
	zmat = allocMatrix(zmat);
	float **res;
	res = allocMatrix(res);
	
	zmat[0][0]=cos(az);  zmat[0][1]=sin(az);  zmat[0][2]=0;  zmat[0][3]=0;
	zmat[1][0]= -sin(az); zmat[1][1]=cos(az);  zmat[1][2]=0;  zmat[1][3]=0;
	zmat[2][0]=0;        zmat[2][1]=0;        zmat[2][2]=1;  zmat[2][3]=0;
	zmat[3][0]=0;        zmat[3][1]=0;        zmat[3][2]=0;  zmat[3][3]=1;

	MatMult(zmat, mat, res);
	MatCopy(res, mat);
	return mat;
}
	
	   

void TransformObj(Object3D* obj, float **transMat)
{
	int i;
	Point res;
	for(i=0;i<obj->PointList->getCount();i++)
	{
		Point *pt = (*(obj->PointList))[i];
		VecMultMatrix(pt,transMat,&res);
		pt->x = res.x;
		pt->y = res.y;
		pt->z = res.z;
		pt->calcDist();
	}

	for(i=0;i<obj->TriangleList->getCount();i++)
	{
		(*(obj->TriangleList))[i]->calcNormal();
	}
}
		


	
	



/*		
 void main()
 {
  float **m;
  m=allocMatrix(m);
  MatIdentity(m);
  Point *p1,*p2,*p3;
  p1=new Point(0,0,1);
  p2=new Point(0,1,4);
  p3=new Point(1,0,3);
  Point result;
  */
  /*Triangle *tr = new Triangle(p1,p2,p3);
  XColor xc;
  Facet *f =new Facet(tr,xc);
  createMatrix(f,m);*/
/*
  for(int i=0;i<4;i++)
	  for(int j=0;j<4;j++)
	  {
		  cout<<"\nEnter"<<i<<" ,"<<j<<"::"<<m[i][j];
                 
	  }
  
  Rotatex(m,M_PI_2);
  VecMultMatrix(p1,m,&result);
  p1->printOn(cerr);
  cerr << "====>";
  result.printOn(cerr);
  MatIdentity(m);
  m=Translate(m,3,4,5);
  VecMultMatrix(p2,m,&result);
  p2->printOn(cerr); cerr << "=====>" ; result.printOn(cerr);
  
  //createFacet(m,f);
  //f->print();
 }*/ 

#endif
