#ifndef __CONE_CPP__

#define __CONE_CPP__

#include "include.cpp"

#include "3Dmathdef.cpp"
#include "3Dfacet.cpp"
#include "obj3D.cpp"


Object3D *
getCordCone (float radius, float height, float step, XColor col)
{
  list < Point > *Pointlist = new list < Point >;
  list < Triangle > *Trilist = new list < Triangle >;
  list < Facet > *Facetlist = new list < Facet >;
  Point *pt1, *pt2, *Op, *Ap;
  Facet *f1, *f2;
  Triangle *t1, *t2;
  int c = 0;
  step = 1 / step;
  step *= M_PI;
  cout << "Inside get cone";
  Op = new Point (0, 0, 0);
  Ap = new Point (0, height, 0);
  Op = Pointlist->insInRear (Op);
  Ap = Pointlist->insInRear (Ap);
  XColor col2;
  col2.red = 0;
  col2.green = 0x7fff;
  col2.blue = 0;

  /* pt1=new Point(radius*cos(0),0,radius*sin(0));
     pt2=new Point(radius*cos(0),0,radius*sin(0)); */

  for (float theta = 0.0; theta >= -2 * M_PI; theta -= step)
    {
      pt1 = new Point (radius * cos (theta), 0, radius * sin (theta));
      pt1 = Pointlist->insInRear (pt1);
      pt2 =
	new Point (radius * cos (theta - step), 0,
		   radius * sin (theta - step));
      pt2 = Pointlist->insInRear (pt2);
      t1 = new Triangle (pt1, pt2, Op);
      t1 = Trilist->insInRear (t1);
      f1 = new Facet (t1, col);
      f1 = Facetlist->insInRear (f1);
      t2 = new Triangle (pt1, Ap, pt2);
      t2 = Trilist->insInRear (t2);
      f2 = new Facet (t2, col);
      f2 = Facetlist->insInRear (f2);
    }

  cout << endl << "****Number Of Facets: " << Facetlist->getCount ();
  cout << endl << "****Number Of Triangles: " << Trilist->getCount ();
  cout << endl << "****Number Of Points: " << Pointlist->getCount ();

  Object3D *obj = new Object3D;
  obj->PointList = Pointlist;
  obj->TriangleList = Trilist;
  obj->FacetList = Facetlist;
  return obj;
}

#endif
