#ifndef __CYLINDER_CPP__

#define __CYLINDER_CPP__

#include "include.cpp"

#include "3Dmathdef.cpp"
#include "3Dfacet.cpp"
#include "obj3D.cpp"




Object3D *
getCordCyl (float radius, float height, float step, XColor col)
{

  Point *pt1, *pt2, *pt3, *pt4, *Op, *Ap;
  Facet *f1, *f2;
  Triangle *t1, *t2;
  list < Point > *Pointlist = new list < Point >;
  list < Triangle > *Trilist = new list < Triangle >;
  list < Facet > *Facetlist = new list < Facet >;
  Op = new Point (0, 0, 0);
  Ap = new Point (0, height, 0);
  Op = Pointlist->insInRear (Op);
  Ap = Pointlist->insInRear (Ap);

  step = 1 / step;
  step *= M_PI;
  for (float theta = 0.0; theta <= 2 * M_PI; theta += step)
    {
      Point *pt1 = new Point (radius * cos (theta), 0, radius * sin (theta));
      pt1 = Pointlist->insInRear (pt1);
      Point *pt2 =
	new Point (radius * cos (theta + step), 0,
		   radius * sin (theta + step));
      pt2 = Pointlist->insInRear (pt2);
      Point *pt3 =
	new Point (radius * cos (theta), height, radius * sin (theta));
      pt3 = Pointlist->insInRear (pt3);
      Point *pt4 =
	new Point (radius * cos (theta + step), height,
		   radius * sin (theta + step));
      pt4 = Pointlist->insInRear (pt4);

      Triangle *t1 = new Triangle (pt1, Op, pt2);
      t1 = Trilist->insInRear (t1);
      Facet *f1 = new Facet (t1, col);
      f1 = Facetlist->insInRear (f1);

      Triangle *t2 = new Triangle (pt3, pt4, Ap);
      t2 = Trilist->insInRear (t2);
      Facet *f2 = new Facet (t2, col);
      f2 = Facetlist->insInRear (f2);

      Triangle *t3 = new Triangle (pt1, pt2, pt3);
      t3 = Trilist->insInRear (t3);
      Facet *f3 = new Facet (t3, col);
      f3 = Facetlist->insInRear (f3);

      Triangle *t4 = new Triangle (pt2, pt4, pt3);
      t4 = Trilist->insInRear (t4);
      Facet *f4 = new Facet (t4, col);
      f4 = (Facet *) (Facetlist->insInRear (f4));

    }

  cout << endl << "****Number Of Facets: " << Facetlist->getCount ();
  cout << endl << "****Number Of Triangles: " << Trilist->getCount ();
  cout << endl << "****Number Of Points: " << Pointlist->getCount ();

  Object3D *obj = new Object3D;
  obj->PointList = Pointlist;
  obj->TriangleList = Trilist;
  obj->FacetList = Facetlist;

  return obj;

}


#endif
